<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Rss
  {

   function __construct() { }

   public static function renderHeadRss($w3,$languageID)
    {
     // Render Rss header
	 $title       = wm3Rss::utf8Specialchar(wm3Util::quoteHTML($w3->getPreferencesContents('browser_bar_title')));
	 $link        = "http://".wm3Rss::utf8Specialchar(wm3Util::quoteHTML($w3->getPreferences('site_address')));
	 $description = wm3Rss::utf8Specialchar(wm3Util::quoteHTML($w3->getPreferencesContents('title')));
	 $date        = date("D, j M Y G:i:s O",time()); // Date format is "Tue, 05 Aug 2008 13:45:00 +0200"
	 $generator   = "Webmatic ".WM3_cVERSION;
     $copyright   = wm3Rss::utf8Specialchar(wm3Util::quoteHTML($w3->getPreferencesContents('browser_bar_title')));
	 switch($languageID)
	  {
	   case WM3_cLANGUAGE_EN: { $language = "en-en"; break; }
	   case WM3_cLANGUAGE_IT: { $language = "it-it"; break; }
	   case WM3_cLANGUAGE_FR: { $language = "fr-fr"; break; }
	   case WM3_cLANGUAGE_DE: { $language = "de-de"; break; }
	   case WM3_cLANGUAGE_ES: { $language = "es-es"; break; }
	   case WM3_cLANGUAGE_NL: { $language = "nl-nl"; break; }
	   default:               { $language = ""; }
	  }
	 header("Content-type: text/xml; charset=utf-8");
     return "<?xml version=\"1.0\" encoding=\"utf-8\"?>
             <?xml-stylesheet href=\"".WM3_cPATH_INCLUDE."rss.css\" type=\"text/css\" media=\"screen\"?>
             <rss version=\"2.0\">
			 <channel>
			 <title>$title</title>
             <link>$link</link>
             <description>$description</description>
             <pubDate>$date</pubDate>
             <generator>$generator</generator>
             <copyright>$copyright</copyright>
             <language>$language</language>";
    }

   public static function renderItemRss($w3,$title,$link,$content,$ts,$author,$comments,$category)
    {
     // Render Rss header
     $title    = wm3Rss::utf8Specialchar(wm3Util::quoteHTML($title));
	 $link     = "http://".wm3Rss::utf8Specialchar(wm3Util::quoteHTML($w3->getPreferences('site_address')."/$link"));
     $content  = str_replace(']]>',']]&gt;',$content);
     $content  = wm3Rss::utf8Specialchar($content);
	 $date     = date("D, j M Y G:i:s O",$ts); // Date format is "Tue, 05 Aug 2008 13:45:00 +0200"
	 $author   = wm3Rss::utf8Specialchar(wm3Util::quoteHTML($author));
	 $comments = "http://".wm3Rss::utf8Specialchar(wm3Util::quoteHTML($w3->getPreferences('site_address')."/$comments"));
     $category = wm3Rss::utf8Specialchar(wm3Util::quoteHTML($category));
     return "<item>
	          <title>$title</title>
	          <link>$link</link>
	          <description><![CDATA[$content]]></description>
	          <pubDate>$date</pubDate>
	          <author>$author</author>
              <comments>$comments</comments>
              <category>$category</category>
             </item>";
    }

   public static function renderFootRss($w3)
    {
     // Render Rss foot
     return "</channel></rss>";
    }

   public static function utf8Specialchar($str)
    {
	 // Convert utf8 special char
 	 $_ARRAY[127]='?';  $_ARRAY[128]='€';  $_ARRAY[129]='?'; $_ARRAY[130]=','; $_ARRAY[131]='ƒ'; $_ARRAY[132]='„';
     $_ARRAY[133]='…';  $_ARRAY[134]='†';  $_ARRAY[135]='‡'; $_ARRAY[136]='^'; $_ARRAY[137]='‰'; $_ARRAY[138]='Š';
     $_ARRAY[139]='‹';  $_ARRAY[140]='Œ';  $_ARRAY[141]='?'; $_ARRAY[142]='Ž'; $_ARRAY[143]='?'; $_ARRAY[144]='?';
     $_ARRAY[145]='\''; $_ARRAY[146]='\''; $_ARRAY[147]='"'; $_ARRAY[148]='"'; $_ARRAY[149]='•'; $_ARRAY[150]='-';
     $_ARRAY[151]='-';  $_ARRAY[152]='~';  $_ARRAY[153]='™'; $_ARRAY[154]='š'; $_ARRAY[155]='›'; $_ARRAY[156]='œ';
     $_ARRAY[157]='?';  $_ARRAY[158]='ž';  $_ARRAY[159]='Ÿ'; $_ARRAY[160]=' '; $_ARRAY[161]='¡'; $_ARRAY[162]='¢';
     $_ARRAY[163]='£';  $_ARRAY[164]='¤';  $_ARRAY[165]='¥'; $_ARRAY[166]='¦'; $_ARRAY[167]='§'; $_ARRAY[168]='¨';
     $_ARRAY[169]='©';  $_ARRAY[170]='ª';  $_ARRAY[171]='«'; $_ARRAY[172]='¬'; $_ARRAY[173]=' '; $_ARRAY[174]='®';
     $_ARRAY[175]='¯';  $_ARRAY[176]='°';  $_ARRAY[177]='±'; $_ARRAY[178]='²'; $_ARRAY[179]='³'; $_ARRAY[180]='´';
     $_ARRAY[181]='µ';  $_ARRAY[182]='¶';  $_ARRAY[183]='·'; $_ARRAY[184]='¸'; $_ARRAY[185]='¹'; $_ARRAY[186]='°';
     $_ARRAY[187]='»';  $_ARRAY[188]='¼';  $_ARRAY[189]='½'; $_ARRAY[190]='¾'; $_ARRAY[191]='¿'; $_ARRAY[192]='À';
     $_ARRAY[193]='Á';  $_ARRAY[194]='Â';  $_ARRAY[195]='Ã'; $_ARRAY[196]='Ä'; $_ARRAY[197]='Å'; $_ARRAY[198]='Æ';
     $_ARRAY[199]='Ç';  $_ARRAY[200]='È';  $_ARRAY[201]='É'; $_ARRAY[202]='Ê'; $_ARRAY[203]='Ë'; $_ARRAY[204]='Ì';
     $_ARRAY[205]='Í';  $_ARRAY[206]='Î';  $_ARRAY[207]='Ï'; $_ARRAY[208]='Ð'; $_ARRAY[209]='Ñ'; $_ARRAY[210]='Ò';
     $_ARRAY[211]='Ó';  $_ARRAY[212]='Ô';  $_ARRAY[213]='Õ'; $_ARRAY[214]='Ö'; $_ARRAY[215]='×'; $_ARRAY[216]='Ø';
     $_ARRAY[217]='Ù';  $_ARRAY[218]='Ú';  $_ARRAY[219]='Û'; $_ARRAY[220]='Ü'; $_ARRAY[221]='Ý'; $_ARRAY[222]='Þ';
     $_ARRAY[223]='ß';  $_ARRAY[224]='à';  $_ARRAY[225]='á'; $_ARRAY[226]='â'; $_ARRAY[227]='ã'; $_ARRAY[228]='ä';
     $_ARRAY[229]='å';  $_ARRAY[230]='æ';  $_ARRAY[231]='ç'; $_ARRAY[232]='è'; $_ARRAY[233]='é'; $_ARRAY[234]='ê';
     $_ARRAY[235]='ë';  $_ARRAY[236]='ì';  $_ARRAY[237]='í'; $_ARRAY[238]='î'; $_ARRAY[239]='ï'; $_ARRAY[240]='ð';
     $_ARRAY[241]='ñ';  $_ARRAY[242]='ò';  $_ARRAY[243]='ó'; $_ARRAY[244]='ô'; $_ARRAY[245]='õ'; $_ARRAY[246]='ö';
     $_ARRAY[247]='÷';  $_ARRAY[248]='ø';  $_ARRAY[249]='ù'; $_ARRAY[250]='ú'; $_ARRAY[251]='û'; $_ARRAY[252]='ü';
     $_ARRAY[253]='ý';  $_ARRAY[254]='þ';  $_ARRAY[255]='ÿ';

     $out = "";
     for($i=0;$i<strlen($str);$i++)
      {
       $asc=ord($str[$i]);
       if($asc>=127 && $asc<=255) { $n=$_ARRAY[$asc]; }
       else                       { if($asc<32) $n=''; else $n=$str[$i]; }
       $out.=$n;
      }
     return $out;
    }

  }

?>
